﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Drawing;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Networks.Programmable;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Networks {
  [Item("KSPTSP Concurrent-Control Network", "An optimization network which connects a KSP and a TSP.")]
  [Creatable("Optimization Networks")]
  [StorableClass]
  public class KSPTSPConcurrentControlNetwork : ProgrammableNetwork {
    public static new Image StaticItemImage {
      get { return HeuristicLab.Common.Resources.VSImageLibrary.Module; }
    }

    protected override string CodeTemplate {
      get { return ReadCodeTemplate("HeuristicLab.Networks.KSPTSPConcurrentControlNetworkCode.cs"); }
    }

    [StorableConstructor]
    protected KSPTSPConcurrentControlNetwork(bool deserializing) : base(deserializing) { }
    protected KSPTSPConcurrentControlNetwork(KSPTSPConcurrentControlNetwork original, Cloner cloner) : base(original, cloner) { }
    public KSPTSPConcurrentControlNetwork() : base("KSPTSPConcurrentControlNetwork") { }
    public KSPTSPConcurrentControlNetwork(string name) : base(name) { }
    public KSPTSPConcurrentControlNetwork(string name, string description) : base(name, description) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new KSPTSPConcurrentControlNetwork(this, cloner);
    }
  }
}
